Index: branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecCfg.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecCfg.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecTop.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -165,5 +165,6 @@
   Bool firstSlice        = true; 
 #endif
- 
+  Bool loopFiltered = false;
+
   while (!!bitstreamFile)
   {
@@ -296,11 +297,16 @@
       }
     }
-    if (bNewPicture || !bitstreamFile)
+    if (bNewPicture || !bitstreamFile || nalu.m_nalUnitType == NAL_UNIT_EOS )
     {
 #if H_MV
       assert( decIdxLastPic != -1 ); 
+      // TODO add loop filtered variable here
       m_tDecTop[decIdxLastPic]->endPicDecoding(poc, pcListPic, m_targetDecLayerIdSet );
 #else
-      m_cTDecTop.executeLoopFilters(poc, pcListPic);
+      if (!loopFiltered || bitstreamFile)
+      {
+        m_cTDecTop.executeLoopFilters(poc, pcListPic);
+      }
+      loopFiltered = (nalu.m_nalUnitType == NAL_UNIT_EOS);
 #endif
     }
@@ -351,4 +357,12 @@
 #endif
       }
+      if (nalu.m_nalUnitType == NAL_UNIT_EOS)
+      {
+#if H_MV
+        xFlushOutput( pcListPic, decIdxLastPic );
+#else
+        xFlushOutput( pcListPic );
+#endif
+      }
       // write reconstruction to file
       if(bNewPicture)
@@ -462,4 +476,10 @@
 #endif
 {
+
+  if (pcListPic->empty())
+  {
+    return;
+  }
+
   TComList<TComPic*>::iterator iterPic   = pcListPic->begin();
   Int numPicsNotYetDisplayed = 0;
@@ -647,5 +667,5 @@
 #endif
 {
-  if(!pcListPic)
+  if(!pcListPic || pcListPic->empty())
   {
     return;
Index: branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecTop.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/TAppDecTop.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/decmain.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/decmain.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppDecoder/decmain.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -492,6 +492,4 @@
   ("RDOQTS",                        m_useRDOQTS,                true )
   ("RDpenalty",                     m_rdPenalty,                0,  "RD-penalty for 32x32 TU for intra in non-intra slices. 0:disbaled  1:RD-penalty  2:maximum RD-penalty")
-  // Entropy coding parameters
-  ("SBACRD",                         m_bUseSBACRD,                      true, "SBAC based RD estimation")
   
   // Deblocking filter parameters
@@ -539,5 +537,4 @@
   ("MaxNumOffsetsPerPic",      m_maxNumOffsetsPerPic,       2048,  "Max number of SAO offset per picture (Default: 2048)")   
   ("SAOLcuBoundary",           m_saoLcuBoundary,            false, "0: right/bottom LCU boundary areas skipped from SAO parameter estimation, 1: non-deblocked pixels are used for those areas")
-  ("SAOLcuBasedOptimization",  m_saoLcuBasedOptimization,   true,  "0: SAO picture-based optimization, 1: SAO LCU-based optimization ")
   ("SliceMode",                m_sliceMode,                0,     "0: Disable all Recon slice limits, 1: Enforce max # of LCUs, 2: Enforce max # of bytes, 3:specify tiles per dependent slice")
   ("SliceArgument",            m_sliceArgument,            0,     "Depending on SliceMode being:"
@@ -559,6 +556,4 @@
   ("PCMInputBitDepthFlag",     m_bPCMInputBitDepthFlag,     true)
   ("PCMFilterDisableFlag",     m_bPCMFilterDisableFlag,    false)
-
-  ("LosslessCuEnabled",        m_useLossless, false)
 
   ("WeightedPredP,-wpP",          m_useWeightedPred,               false,      "Use weighted prediction in P slices")
@@ -590,12 +585,7 @@
   ("CFM", m_bUseCbfFastMode, false, "Cbf fast mode setting")
   ("ESD", m_useEarlySkipDetection, false, "Early SKIP detection setting")
-#if RATE_CONTROL_LAMBDA_DOMAIN
   ( "RateControl",         m_RCEnableRateControl,   false, "Rate control: enable rate control" )
   ( "TargetBitrate",       m_RCTargetBitrate,           0, "Rate control: target bitrate" )
-#if M0036_RC_IMPROVEMENT
   ( "KeepHierarchicalBit", m_RCKeepHierarchicalBit,     0, "Rate control: 0: equal bit allocation; 1: fixed ratio bit allocation; 2: adaptive ratio bit allocation" )
-#else
-  ( "KeepHierarchicalBit", m_RCKeepHierarchicalBit, false, "Rate control: keep hierarchical bit allocation in rate control algorithm" )
-#endif
   ( "LCULevelRateControl", m_RCLCULevelRC,           true, "Rate control: true: LCU level RC; false: picture level RC" )
   ( "RCLCUSeparateModel",  m_RCUseLCUSeparateModel,  true, "Rate control: use LCU level separate R-lambda model" )
@@ -610,18 +600,4 @@
   ("DepthMADPred, -dm", m_depthMADPred, (UInt)0, "Depth based MAD prediction on/off")
 #endif
-#else
-  ("RateCtrl,-rc", m_enableRateCtrl, false, "Rate control on/off")
-  ("TargetBitrate,-tbr", m_targetBitrate, 0, "Input target bitrate")
-  ("NumLCUInUnit,-nu", m_numLCUInUnit, 0, "Number of LCUs in an Unit")
-
-#if KWU_RC_VIEWRC_E0227
-  ("ViewWiseTargetBits, -vtbr" ,  m_viewTargetBits,  std::vector<Int>(1, 32), "View-wise target bit-rate setting")
-  ("TargetBitAssign, -ta", m_viewWiseRateCtrl, false, "View-wise rate control on/off")
-#endif
-#if KWU_RC_MADPRED_E0227
-  ("DepthMADPred, -dm", m_depthMADPred, (UInt)0, "Depth based MAD prediction on/off")
-#endif
-#endif
-
 #if H_MV
 
@@ -2021,5 +1997,5 @@
       m_maxTempLayer = m_GOPList[i].m_temporalId+1;
     }
-    xConfirmPara(m_GOPList[i].m_sliceType!='B'&&m_GOPList[i].m_sliceType!='P', "Slice type must be equal to B or P");
+    xConfirmPara(m_GOPList[i].m_sliceType!='B'&&m_GOPList[i].m_sliceType!='P'&&m_GOPList[i].m_sliceType!='I', "Slice type must be equal to B or P or I");
   }
   for(Int i=0; i<MAX_TLAYER; i++)
@@ -2172,5 +2148,4 @@
   }
 
-#if RATE_CONTROL_LAMBDA_DOMAIN
   if ( m_RCEnableRateControl )
   {
@@ -2185,19 +2160,4 @@
     xConfirmPara( m_uiDeltaQpRD > 0, "Rate control cannot be used together with slice level multiple-QP optimization!\n" );
   }
-#else
-  if(m_enableRateCtrl)
-  {
-    Int numLCUInWidth  = (m_iSourceWidth  / m_uiMaxCUWidth) + (( m_iSourceWidth  %  m_uiMaxCUWidth ) ? 1 : 0);
-    Int numLCUInHeight = (m_iSourceHeight / m_uiMaxCUHeight)+ (( m_iSourceHeight %  m_uiMaxCUHeight) ? 1 : 0);
-    Int numLCUInPic    =  numLCUInWidth * numLCUInHeight;
-
-    xConfirmPara( (numLCUInPic % m_numLCUInUnit) != 0, "total number of LCUs in a frame should be completely divided by NumLCUInUnit" );
-
-#if !KWU_FIX_URQ
-    m_iMaxDeltaQP       = MAX_DELTA_QP;
-#endif
-    m_iMaxCuDQPDepth    = MAX_CUDQP_DEPTH;
-  }
-#endif
 #if H_MV
   // VPS VUI
@@ -2223,5 +2183,5 @@
 #endif
 
-  xConfirmPara(!m_TransquantBypassEnableFlag && m_CUTransquantBypassFlagValue, "CUTransquantBypassFlagValue cannot be 1 when TransquantBypassEnableFlag is 0");
+  xConfirmPara(!m_TransquantBypassEnableFlag && m_CUTransquantBypassFlagForce, "CUTransquantBypassFlagForce cannot be 1 when TransquantBypassEnableFlag is 0");
 
   xConfirmPara(m_log2ParallelMergeLevel < 2, "Log2ParallelMergeLevel should be larger than or equal to 2");
@@ -2343,5 +2303,4 @@
   printf("Internal bit depth           : (Y:%d, C:%d)\n", m_internalBitDepthY, m_internalBitDepthC );
   printf("PCM sample bit depth         : (Y:%d, C:%d)\n", g_uiPCMBitDepthLuma, g_uiPCMBitDepthChroma );
-#if RATE_CONTROL_LAMBDA_DOMAIN
   printf("RateControl                  : %d\n", m_RCEnableRateControl );
   if(m_RCEnableRateControl)
@@ -2373,31 +2332,4 @@
 #endif
   }
-#else
-  printf("RateControl                  : %d\n", m_enableRateCtrl);
-  if(m_enableRateCtrl)
-  {
-    printf("TargetBitrate                : %d\n", m_targetBitrate);
-    printf("NumLCUInUnit                 : %d\n", m_numLCUInUnit);
-
-#if KWU_RC_MADPRED_E0227
-    printf("Depth based MAD prediction   : %d\n", m_depthMADPred);
-#endif
-#if KWU_RC_VIEWRC_E0227
-    printf("View-wise Rate control       : %d\n", m_viewWiseRateCtrl);
-    if(m_viewWiseRateCtrl)
-    {
-
-      printf("ViewWiseTargetBits           : ");
-      for (Int i = 0 ; i < m_iNumberOfViews ; i++)
-        printf("%d ", m_viewTargetBits[i]);
-      printf("\n");
-    }
-    else
-    {
-      printf("TargetBitrate                : %d\n", m_targetBitrate );
-    }
-#endif
-  }
-#endif
   printf("Max Num Merge Candidates     : %d\n", m_maxNumMergeCand);
 #if H_3D
@@ -2458,7 +2390,12 @@
 #endif
   printf("PCM:%d ", (m_usePCM && (1<<m_uiPCMLog2MinSize) <= m_uiMaxCUWidth)? 1 : 0);
-  printf("SAOLcuBasedOptimization:%d ", (m_saoLcuBasedOptimization)?(1):(0));
-
-  printf("LosslessCuEnabled:%d ", (m_useLossless)? 1:0 );
+  if (m_TransquantBypassEnableFlag && m_CUTransquantBypassFlagForce)
+  {
+    printf("TransQuantBypassEnabled: =1 ");
+  }
+  else
+  {
+    printf("TransQuantBypassEnabled:%d ", (m_TransquantBypassEnableFlag)? 1:0 );
+  }
   printf("WPP:%d ", (Int)m_useWeightedPred);
   printf("WPB:%d ", (Int)m_useWeightedBiPred);
Index: branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncCfg.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -259,6 +259,5 @@
   Bool      m_bPCMInputBitDepthFlag;                          ///< 0: PCM bit-depth is internal bit-depth. 1: PCM bit-depth is input bit-depth.
 
-  // coding tool (lossless)
-  Bool      m_useLossless;                                    ///< flag for using lossless coding
+  // coding tool (SAO)
 #if H_MV
   std::vector<Bool> m_bUseSAO; 
@@ -268,5 +267,4 @@
   Int       m_maxNumOffsetsPerPic;                            ///< SAO maximun number of offset per picture
   Bool      m_saoLcuBoundary;                                 ///< SAO parameter estimation using non-deblocked pixels for LCU bottom and right boundary areas
-  Bool      m_saoLcuBasedOptimization;                        ///< SAO LCU-based optimization
   // coding tools (loop filter)
 #if H_MV
@@ -372,12 +370,7 @@
   Int       m_TMVPModeId;
   Int       m_signHideFlag;
-#if RATE_CONTROL_LAMBDA_DOMAIN
   Bool      m_RCEnableRateControl;                ///< enable rate control or not
   Int       m_RCTargetBitrate;                    ///< target bitrate when rate control is enabled
-#if M0036_RC_IMPROVEMENT
   Int       m_RCKeepHierarchicalBit;              ///< 0: equal bit allocation; 1: fixed ratio bit allocation; 2: adaptive ratio bit allocation
-#else
-  Bool      m_RCKeepHierarchicalBit;              ///< whether keeping hierarchical bit allocation structure or not
-#endif
   Bool      m_RCLCULevelRC;                       ///< true: LCU level rate control; false: picture level rate control
   Bool      m_RCUseLCUSeparateModel;              ///< use separate R-lambda model at LCU level
@@ -409,5 +402,5 @@
 
   Bool      m_TransquantBypassEnableFlag;                     ///< transquant_bypass_enable_flag setting in PPS.
-  Bool      m_CUTransquantBypassFlagValue;                    ///< if transquant_bypass_enable_flag, the fixed value to use for the per-CU cu_transquant_bypass_flag.
+  Bool      m_CUTransquantBypassFlagForce;                    ///< if transquant_bypass_enable_flag, then, if true, all CU transquant bypass flags will be set to true.
 
   Bool      m_recalculateQPAccordingToLambda;                 ///< recalculate QP value according to the lambda value
Index: branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncTop.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -309,24 +309,11 @@
 #endif
 
-  Int lowestQP;
-  lowestQP =  - 6*(g_bitDepthY - 8); // XXX: check
-
-#if H_MV
-  if ((m_iMaxDeltaQP == 0 ) && (m_iQP[layerIdInVps] == lowestQP) && (m_useLossless == true))
-#else
-  if ((m_iMaxDeltaQP == 0 ) && (m_iQP == lowestQP) && (m_useLossless == true))
-#endif
-  {
-    m_bUseAdaptiveQP = false;
-  }
   m_cTEncTop.setUseAdaptiveQP                ( m_bUseAdaptiveQP  );
   m_cTEncTop.setQPAdaptationRange            ( m_iQPAdaptationRange );
   
   //====== Tool list ========
-  m_cTEncTop.setUseSBACRD                    ( m_bUseSBACRD   );
   m_cTEncTop.setDeltaQpRD                    ( m_uiDeltaQpRD  );
   m_cTEncTop.setUseASR                       ( m_bUseASR      );
   m_cTEncTop.setUseHADME                     ( m_bUseHADME    );
-  m_cTEncTop.setUseLossless                  ( m_useLossless );
 #if H_MV
   m_cTEncTop.setdQPs                         ( m_aidQP[layerIdInVps]   );
@@ -396,5 +383,4 @@
 
   m_cTEncTop.setSaoLcuBoundary (m_saoLcuBoundary);
-  m_cTEncTop.setSaoLcuBasedOptimization (m_saoLcuBasedOptimization);
   m_cTEncTop.setPCMInputBitDepthFlag  ( m_bPCMInputBitDepthFlag); 
   m_cTEncTop.setPCMFilterDisableFlag  ( m_bPCMFilterDisableFlag); 
@@ -461,5 +447,4 @@
   m_cTEncTop.setScalingListFile            ( m_scalingListFile   );
   m_cTEncTop.setSignHideFlag(m_signHideFlag);
-#if RATE_CONTROL_LAMBDA_DOMAIN
 #if KWU_RC_VIEWRC_E0227 || KWU_RC_MADPRED_E0227
   if(!m_cTEncTop.getIsDepth())    //only for texture
@@ -482,10 +467,8 @@
   m_cTEncTop.setInitialQP           ( m_RCInitialQP );
   m_cTEncTop.setForceIntraQP        ( m_RCForceIntraQP );
-
 #if KWU_RC_MADPRED_E0227
   if(m_cTEncTop.getUseRateCtrl() && !m_cTEncTop.getIsDepth())
   {
     m_cTEncTop.setUseDepthMADPred(layerIdInVps ? m_depthMADPred       : 0);
-
     if(m_cTEncTop.getUseDepthMADPred())
     {
@@ -498,5 +481,4 @@
   {
     m_cTEncTop.setUseViewWiseRateCtrl(m_viewWiseRateCtrl);
-
     if(m_iNumberOfViews == 1)
     {
@@ -552,95 +534,6 @@
   }
 #endif
-#else
-#if KWU_RC_VIEWRC_E0227 || KWU_RC_MADPRED_E0227
-  if(!m_cTEncTop.getIsDepth())    //only for texture
-  {
-    m_cTEncTop.setUseRateCtrl         ( m_enableRateCtrl );
-    m_cTEncTop.setTargetBitrate       ( m_targetBitrate );
-    m_cTEncTop.setNumLCUInUnit        ( m_numLCUInUnit);
-  }
-  else
-  {
-    m_cTEncTop.setUseRateCtrl         ( 0 );
-  }
-#else
-  m_cTEncTop.setUseRateCtrl         ( m_enableRateCtrl );
-  m_cTEncTop.setTargetBitrate       ( m_targetBitrate );
-  m_cTEncTop.setNumLCUInUnit        ( m_numLCUInUnit);
-#endif
-
-  
-#if KWU_RC_MADPRED_E0227
-  if(m_cTEncTop.getUseRateCtrl() && !m_cTEncTop.getIsDepth())
-  {
-    m_cTEncTop.setUseDepthMADPred(layerIdInVps ? m_depthMADPred       : 0);
-
-    if(m_cTEncTop.getUseDepthMADPred())
-    {
-      m_cTEncTop.setCamParam(&m_cCameraData);
-    }
-  }
-#endif
-
-#if KWU_RC_VIEWRC_E0227
-  if(m_cTEncTop.getUseRateCtrl() && !m_cTEncTop.getIsDepth())
-  {
-    m_cTEncTop.setUseViewWiseRateCtrl(m_viewWiseRateCtrl);
-    if(m_iNumberOfViews == 1)
-    {
-      if(m_viewWiseRateCtrl)
-      {
-        m_cTEncTop.setTargetBitrate(m_viewTargetBits[layerIdInVps>>1]);
-      }
-      else
-      {
-        m_cTEncTop.setTargetBitrate       ( m_targetBitrate );
-      }
-    }
-    else
-    {
-      if(m_viewWiseRateCtrl)
-      {
-        m_cTEncTop.setTargetBitrate(m_viewTargetBits[layerIdInVps>>1]);
-      }
-      else
-      {
-        if(m_iNumberOfViews == 2)
-        {
-          if(m_cTEncTop.getViewId() == 0)
-          {
-            m_cTEncTop.setTargetBitrate              ( (m_targetBitrate*80)/100 );
-          }
-          else if(m_cTEncTop.getViewId() == 1)
-          {
-            m_cTEncTop.setTargetBitrate              ( (m_targetBitrate*20)/100 );
-          }
-        }
-        else if(m_iNumberOfViews == 3)
-        {
-          if(m_cTEncTop.getViewId() == 0)
-          {
-            m_cTEncTop.setTargetBitrate              ( (m_targetBitrate*66)/100 );
-          }
-          else if(m_cTEncTop.getViewId() == 1)
-          {
-            m_cTEncTop.setTargetBitrate              ( (m_targetBitrate*17)/100 );
-          }
-          else if(m_cTEncTop.getViewId() == 2)
-          {
-            m_cTEncTop.setTargetBitrate              ( (m_targetBitrate*17)/100 );
-          }
-        }
-        else
-        {
-          m_cTEncTop.setTargetBitrate              ( m_targetBitrate );
-        }
-      }
-    }
-  }
-#endif
-#endif
   m_cTEncTop.setTransquantBypassEnableFlag(m_TransquantBypassEnableFlag);
-  m_cTEncTop.setCUTransquantBypassFlagValue(m_CUTransquantBypassFlagValue);
+  m_cTEncTop.setCUTransquantBypassFlagForceValue(m_CUTransquantBypassFlagForce);
   m_cTEncTop.setUseRecalculateQPAccordingToLambda( m_recalculateQPAccordingToLambda );
   m_cTEncTop.setUseStrongIntraSmoothing( m_useStrongIntraSmoothing );
@@ -1203,5 +1096,4 @@
       rateStatsAccum(au, stats);   
     }
-#endif    
   }
 }
@@ -1221,5 +1113,5 @@
     case NAL_UNIT_CODED_SLICE_TRAIL_R:
     case NAL_UNIT_CODED_SLICE_TRAIL_N:
-    case NAL_UNIT_CODED_SLICE_TLA_R:
+    case NAL_UNIT_CODED_SLICE_TSA_R:
     case NAL_UNIT_CODED_SLICE_TSA_N:
     case NAL_UNIT_CODED_SLICE_STSA_R:
Index: branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncTop.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncTop.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/TAppEncTop.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/encmain.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/encmain.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/TAppEncoder/encmain.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2013, ITU/ISO/IEC
+* Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitrates.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitrates.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitrates.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitrates.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitrates.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitrates.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitratesMain.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitratesMain.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/ExtractBitratesMain.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiers.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiers.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiers.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiers.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiers.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiers.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiersMain.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiersMain.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/GuessLambdaModifiersMain.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/RuntimeError.h
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/RuntimeError.h	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/RuntimeError.h	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/encode.shl
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/encode.shl	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/encode.shl	(revision 837)
@@ -4,5 +4,5 @@
 # granted under this license.  
 #
-# Copyright (c) 2010-2012, ITU/ISO/IEC
+# Copyright (c) 2010-2014, ITU/ISO/IEC
 # All rights reserved.
 #
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/encodeCommand.sh
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/encodeCommand.sh	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/encodeCommand.sh	(revision 837)
@@ -6,5 +6,5 @@
 # granted under this license.  
 #
-# Copyright (c) 2010-2012, ITU/ISO/IEC
+# Copyright (c) 2010-2014, ITU/ISO/IEC
 # All rights reserved.
 #
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/makefile
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/makefile	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/makefile	(revision 837)
@@ -4,5 +4,5 @@
 # granted under this license.  
 #
-# Copyright (c) 2010-2012, ITU/ISO/IEC
+# Copyright (c) 2010-2014, ITU/ISO/IEC
 # All rights reserved.
 #
Index: branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/targetBitrates.sh
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/targetBitrates.sh	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/BitrateTargeting/targetBitrates.sh	(revision 837)
@@ -6,5 +6,5 @@
 # granted under this license.  
 #
-# Copyright (c) 2010-2012, ITU/ISO/IEC
+# Copyright (c) 2010-2014, ITU/ISO/IEC
 # All rights reserved.
 #
Index: branches/HTM-10.0rc1-dev0/source/App/utils/annexBbytecount.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/annexBbytecount.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/annexBbytecount.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *
Index: branches/HTM-10.0rc1-dev0/source/App/utils/convert_NtoMbit_YCbCr.cpp
===================================================================
--- branches/HTM-10.0rc1-dev0/source/App/utils/convert_NtoMbit_YCbCr.cpp	(revision 836)
+++ branches/HTM-10.0rc1-dev0/source/App/utils/convert_NtoMbit_YCbCr.cpp	(revision 837)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2012, ITU/ISO/IEC
+ * Copyright (c) 2010-2014, ITU/ISO/IEC
  * All rights reserved.
  *